
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.preview.*;
import com.sun.java.swing.preview.filechooser.*;


public class FileChooserExample {
    static public void main(String argv[]) {
	JFrame    frame = new JFrame("FileChooserExample");
	Container cp    = frame.getContentPane();
	JButton b;
	
	cp.setLayout(new FlowLayout());
	
	b = new JButton("Open");
	b.addActionListener(new ButtonListener(frame));
	cp.add(b);

	frame.pack();
	frame.setVisible(true);
    }

}

class ButtonListener implements ActionListener {
    JFrame frame;
    public ButtonListener(JFrame frame) {
	this.frame = frame;
    }
    public void actionPerformed(ActionEvent e) {
	JFileChooser filechooser = new JFileChooser();

	filechooser.addChoosableFileFilter(new MyFilter());
	filechooser.setFileView(new MyFileView());

	int returnVal = filechooser.showDialog(frame, "Choose It");
    }
}


class MyFilter extends FileFilter {
    final static String jpg = "jpg";
    final static String gif = "gif";
    final static String tiff = "tiff";
    
    // Accept all directories and (gif || jpg || tiff) files.
    public boolean accept(File f) {
	if(f.isDirectory()) {
	    return true;
	}
	String s = f.getName();
	int i = s.lastIndexOf('.');
	if(i > 0 &&  i < s.length() - 1) {
	    String extension = s.substring(i+1).toLowerCase();
	    if (tiff.equals(extension) || gif.equals(extension) || jpg.equals(extension)) {
		return true;
	    } else {
		return false;
	    }
	};
	return false;
    }
    
    // The desctiption of this filter
    public String getDescription() {
	return "Just Images (*.jpg, *.gif, *.tiff)";
    }
}


class MyFileView extends FileView {
    ImageIcon jpgIcon = new ImageIcon("jpgIcon.gif");
    ImageIcon gifIcon = new ImageIcon("gifIcon.gif");
    ImageIcon tiffIcon = new ImageIcon("tiffIcon.gif");
    
    public String getName(File f) {
	return null; // let the L&F FileView figure this out
    }
    
    public String getDescription(File f) {
	return null; // let the L&F FileView figure this out
    }
    
    public String getTypeDescription(File f) {
	String extension = getExtension(f);
	String type = null;
	if(extension != null) {
	    if(extension.equals("jpg")) {
		type = "JPeg Image";
	    } 
	    if(extension.equals("gif")){
		type = "GIF Image";
	    } 
	    if(extension.equals("tiff")) {
		type = "TIFF Image";
	    } 
	}
	return type;
    }
    
    public Icon getIcon(File f) {
	String extension = getExtension(f);
	// System.out.println("extension = " + extension);
	Icon icon = null;
	if(extension != null) {
	    if(extension.equals("jpg")) {
		icon = jpgIcon;
	    } 
	    if(extension.equals("gif")) {
		icon = gifIcon;
	    } 
	    if(extension.equals("tiff")) {
		icon = tiffIcon;
	    } 
	}
	return icon;
    }
    
    public Boolean isTraversable(File f) {
	return null; // let the L&F FileView figure this out
    }
    
    // Get the extension of this file. Code is factored out
    // because we use this in both getIcon and getTypeDescription
    private String getExtension(File f) {
	String ext = null;
	String s = f.getName();
	int i = s.lastIndexOf('.');
	if(i > 0 &&  i < s.length() - 1) {
	    ext = s.substring(i+1).toLowerCase();
	}
	return ext;
    }
}
